%%%%%%%%%%%%%%%%%%%%%%%%
%  cleaning workspace
close all
clear all
clc
clf
%% Initialize the ROS environment
try
rosinit; 
end
start
%% customize params
fixed_step_size = 1/120;  %step of simulink
UAV_NUM = 0;
AUTOLAND = true;  %whether autoland when simulation ends
TELLO_PLOT = false;
fignum = 'eight_shaped';
draw_gif = false;
battery_threshold = 15;
z_d_for_land = -0.2;

XMIN = -0.8; XMAX = 0.8;
YMIN = -1.2; YMAX = 1.2;
ZMIN = -1.6; ZMAX = -0.5;
axis([XMIN*1.2 XMAX*1.2 YMIN*1.2 YMAX*1.2 ZMIN*1.2 ZMAX*0.8]);

xlabel('X(m)');
ylabel('Y(m)');
zlabel('Z(m)');
box on;

w1 = 0.4;
w2 = 0.2;
act_end = 4*pi/w1;

%desired position
a = XMAX;
b = YMAX;
k = (ZMAX - ZMIN)/(YMAX - YMIN);
bb = (ZMIN*YMAX - ZMAX*YMIN)/(YMAX - YMIN);
ZA = ZMAX - ZMIN;
tb = 2.7;
tb2 = tb;
tb3 = tb*2;
tb4 = tb*3;
tb5 = tb*4;
tb6 = tb*5;
tb7 = tb*6;
tb8 = tb*7;

R = 1;
omega = 0.3;  %转圈的角速度
%speed limit to 2*R*omega

sim_start_time = 2;  %for system stable
sim_end_time = 15*act_end + 4;

%IP address and ports for all eight tello
UDP_REC_IP = '127.0.0.1';
UDP_SEND_IP = '127.0.0.1'; %192.168.207.9
%1_2
TELLO1_NUM = uint8(1);
TELLO1_SEND_PORT = 25000;
TELLO1_REC_PORT = 26000;
TELLO2_NUM = uint8(2);
TELLO2_SEND_PORT = 25001;
TELLO2_REC_PORT = 26001;
%3_4
TELLO3_NUM = uint8(3);
TELLO3_SEND_PORT = 25002;
TELLO3_REC_PORT = 26002;
TELLO4_NUM = uint8(4);
TELLO4_SEND_PORT = 25003;
TELLO4_REC_PORT = 26003;
%5_6
TELLO5_NUM = uint8(5);
TELLO5_SEND_PORT = 25004;
TELLO5_REC_PORT = 26004;
TELLO6_NUM = uint8(6);
TELLO6_SEND_PORT = 25005;
TELLO6_REC_PORT = 26005;
%7_8
TELLO7_NUM = uint8(7);
TELLO7_SEND_PORT = 25006;
TELLO7_REC_PORT = 26006;
TELLO8_NUM = uint8(8);
TELLO8_SEND_PORT = 25007;
TELLO8_REC_PORT = 26007;


%%open simulator
%e2_3_kalman_filtre_2017.slx